﻿/**
* GraphicButton by gskinner.com
* Visit www.gskinner.com for documentation, updates and more free code.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/
import mx.events.EventDispatcher;
//
class com.gskinner.controls.GraphicButton extends MovieClip {
// ui elements:
	private var hitAreaMC:MovieClip;
	private var _enabled:Boolean = true;
	private var _selected:Boolean = false;

// methods for EventDispatcher:
	public var addEventListener:Function;
	public var removeEventListener:Function;
	private var dispatchEvent:Function;

// initialization:
	private function GraphicButton() {
		EventDispatcher.initialize(this);
	}
	private function onLoad() {
		enabled = _enabled;
		selected = _selected;
		if (hitAreaMC) { hitArea = hitAreaMC; }
	}

	private function onRollOver():Void {
		if (!_enabled) { return; }
		dispatchEvent({type:"over"});
		if (!_selected) { this.gotoAndPlay("over"); }
	}
	private function onDragOver():Void { onRollOver(); }

	private function onRollOut():Void {
		if (!_enabled) { return; }
		dispatchEvent({type:"out"});
		if (!_selected) {
			this.gotoAndPlay("up"); // in case there is no out state
			this.gotoAndPlay("out");
		}
	}

	private function onDragOut():Void { onRollOut();}

	private function onPress():Void {
		if (!_enabled) { return; }
		dispatchEvent({type:"down"});
		this.gotoAndPlay("down");
	}

	private function onRelease():Void {
		if (!_enabled) { return; }
		dispatchEvent({type:"click"});
		onRollOver();
	}

	public function get enabled():Boolean {
		return _enabled;
	}
	public function set enabled(p_enabled:Boolean):Void {
		_enabled = Boolean(p_enabled);
		useHandCursor = p_enabled;
		this.gotoAndPlay("up");
		if (!_enabled) { this.gotoAndPlay("disabled"); }
	}
	public function get selected():Boolean { return _selected; }
	public function set selected(p_selected:Boolean):Void {
		_selected = p_selected;
		var s:String = (_selected) ?  "selected" : (_enabled) ? "up" : "disabled";
		this.gotoAndPlay(s);
	}
}