﻿/**
* MovieClipLoader2 by Wes Gorgichuk of gskinner.com
* Visit www.gskinner.com for documentation, updates and more free code.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/
import mx.events.EventDispatcher;
//
class com.gskinner.net.MovieClipLoader2 {
// constants:
	public static var CLASS_REF = com.gskinner.net.MovieClipLoader2;
	
// public properties:
	public var timeout:Number = 1000;
// private properties:
	private var loaderRef:MovieClipLoader;
	
// EventDispatcher Mix-ins:
	public var addEventListener:Function;
	public var removeEventListener:Function;
	private var dispatchEvent:Function;

// initialization:
	public function MovieClipLoader2() {
		EventDispatcher.initialize(this);
		loaderRef = new MovieClipLoader();
		loaderRef.addListener(this);
	}

// public methods:
	public function loadClip (p_path:String, p_holder:MovieClip):Boolean { return loaderRef.loadClip(p_path, p_holder); }
	public function getProgress ():Void { loaderRef.getProgress(); }
	public function removeListener(p_listener:Object):Boolean { return loaderRef.removeListener(p_listener); }
// semi-private methods:

// private methods:
	private function onLoadComplete(p_target:MovieClip, p_httpStatus:Number):Void {
		dispatchEvent({type:"loadComplete", target:p_target, status:p_httpStatus});
	}
	private function onLoadError (p_target:MovieClip, p_errorCode:String, p_httpStatus:Number):Void {
		dispatchEvent({type:"loadError ", target:p_target, errorCode:p_errorCode, httpStatus:p_httpStatus});	
	}
	private function onLoadInit(p_target:MovieClip):Void {
		dispatchEvent({type:"loadInit", target:p_target});	
	}
	private function onLoadProgress(p_target:MovieClip, p_loadedBytes:Number, p_totalBytes:Number):Void {
		dispatchEvent({type:"loadProgress", target:p_target, loadedBytes:p_loadedBytes, totalBytes:p_totalBytes});	
	}
	private function onLoadStart(p_target:MovieClip):Void {
		dispatchEvent({type:"loadStart ", target:p_target});
	}
}