﻿/*
* This Alpha Video demo was created by Wes Gorgichuk of gskinner.com.
* Visit www.gskinner.com/blog for other samples, and more free code.
*/
import mx.video.FLVPlayback;
import mx.controls.Button;
import com.gskinner.controls.GraphicButton;
import com.gskinner.events.EventProxy;
import flash.filters.BlurFilter;
import mx.transitions.Tween;
import mx.transitions.easing.Elastic;
//
class com.gskinner.videodemo.Main extends MovieClip {
// Constants:
	public static var CLASS_REF = com.gskinner.videodemo.Main;
	public static var LINKAGE_ID:String = "com.gskinner.videodemo.Main";
	private static var DEFAULT_BG:String = 'one';
	private static var TOTAL_VIDEOS:Number = 4;
// Public Properties:
// Private Properties:
	private var loopEvent:EventProxy;
	private var walkEvent:EventProxy;
	private var blur:BlurFilter;
	private var actionButtWidth:Number = 75;
	private var actionButtHeight:Number = 35;
	private var loadedCount:Number = 0;
// UI Elements:

// ** AUTO-UI ELEMENTS **
	private var bg_one:GraphicButton;
	private var bg_two:GraphicButton;
	private var bg_three:GraphicButton;
	private var hatBtn:GraphicButton;
	private var shoeBtn:GraphicButton;
	private var playBtn:Button;
	private var resetBtn:Button;
	private var bg:MovieClip;
	private var buffBar:MovieClip;
	//
	private var hatFlv:FLVPlayback;
	private var shoeFlv:FLVPlayback;
	private var sittingFlv:FLVPlayback;
	private var walkingFlv:FLVPlayback;
// ** END AUTO-UI ELEMENTS **
	
// Initialization:
	private function Main() {}
	private function onLoad():Void { configUI(); }

// Public Methods:
// Semi-Private Methods:

// Private Methods:
	//Change the background image.
	private function setBackground(p_eventObj:Object):Void {
		bg.gotoAndStop(p_eventObj.target._name.split('_')[1]);
	}
	//Plays the hat flv file, and disables the shoe video.
	private function playHatFlv():Void {
		hatBtn.enabled = false;
		hatFlv._visible = true;
		shoeFlv._visible = false;
		shoeBtn.enabled = true;
		setWalkingBlur();
		hatFlv.play();
	}
	//Plays the hat shoe file, and disables the hat video.
	private function playShoeFlv():Void {
		hatBtn.enabled = true;
		hatFlv._visible = false;
		shoeFlv._visible = true;
		shoeBtn.enabled = false;
		setWalkingBlur();
		shoeFlv.play();
	}
	//Apply a Blur filter to the Walking video, we only want to do this once.
	private function setWalkingBlur():Void {
		if (walkingFlv._alpha == 100) {
			walkingFlv.filters = [blur];
			walkingFlv._alpha = 90;
		}
	}
	//Plays the walking flv file, and stops looping on the sitting video.
	private function playWalkingVideo():Void {
		playBtn.enabled = false;
		//
		sittingFlv.filters = [blur];
		sittingFlv._alpha = 75;
		sittingFlv.removeEventListener('stopped', loopEvent);
		playBtn.removeEventListener('click', walkEvent);
		walkingFlv._visible = true;
		walkingFlv.addEventListener('stopped', new EventProxy(this, 'walkingStopped'));
		walkingFlv.play();
	}
	//Event - Fires when the walking video has stopped, so we can animate in the "action" buttons.
	private function walkingStopped():Void {
		shoeBtn._alpha = hatBtn._alpha = 100;
		shoeBtn._width = hatBtn._width = 0;
		shoeBtn._height = hatBtn._height = 0;
		//
		new Tween(hatBtn,'_width', Elastic.easeOut, 0, actionButtWidth, 2, true);
		new Tween(hatBtn,'_height', Elastic.easeOut, 0, actionButtHeight, 2, true);
		//
		new Tween(shoeBtn,'_width', Elastic.easeOut, 0, actionButtWidth, 2, true);
		new Tween(shoeBtn,'_height', Elastic.easeOut, 0, actionButtHeight, 2, true);
		//
		resetBtn.enabled = true;
	}
	//Event - Fired on stop on the Sitting / Hat and Shoe videos, just replays the stopped video file.
	private function loopVideo(p_eventObj:Object):Void {
		p_eventObj.target.play();
	}
	//Event - Called when the Reset Button is clicked, also called onLoad.
	private function reset():Void {
		hatFlv._visible = false;
		shoeFlv._visible = false;
		walkingFlv._visible = false;
		bg.gotoAndStop(DEFAULT_BG);
		//
		if (walkingFlv.stopped) {
			walkingFlv.seek(0);
			sittingFlv.addEventListener('stopped', loopEvent);
			sittingFlv.play();
		}
		walkingFlv._alpha = 100;
		walkingFlv.filters = null;
		//
		sittingFlv.filters = null;
		sittingFlv._alpha = 100;

		if (loadedCount == TOTAL_VIDEOS) {
			playBtn.enabled = true
		}
		hatBtn.enabled = shoeBtn.enabled = true;
		resetBtn.enabled = false;
		shoeBtn._alpha = hatBtn._alpha = 0;
		//
		playBtn.addEventListener('click', walkEvent);
	}
	//Need to load all the videos before playing them.
	//Called from each ready event on each of the FLV files.
	private function countLoaded():Void {
		loadedCount++;
		if (loadedCount == TOTAL_VIDEOS) {
			playBtn.enabled = true;
		}
	}
	//Configure the interface, called onLoad and on click of the Reset button.
	private function configUI():Void {
		blur = new BlurFilter(3,3,1);
		//
		sittingFlv.bufferingBar = buffBar;
		//Background controls
		var changeBgEvent = new EventProxy(this, 'setBackground');
		bg_one.addEventListener('click', changeBgEvent);
		bg_two.addEventListener('click', changeBgEvent);
		bg_three.addEventListener('click', changeBgEvent);
		
		//Walking and sitting controls.
		loopEvent = new EventProxy(this, 'loopVideo');
		walkEvent = new EventProxy(this, 'playWalkingVideo');
		//
		playBtn.enabled = false;
		playBtn.addEventListener('click', walkEvent);
		sittingFlv.addEventListener('stopped', loopEvent);
		hatFlv.addEventListener('stopped',loopEvent);
		shoeFlv.addEventListener('stopped',loopEvent);
		//Hat and Shoe controls
		shoeBtn.addEventListener('click', new EventProxy(this, 'playShoeFlv'));
		hatBtn.addEventListener('click', new EventProxy(this, 'playHatFlv'));
		//
		sittingFlv.addEventListener('ready', new EventProxy(this, 'loopVideo'));
		var countLoadedEvent:EventProxy = new EventProxy(this, 'countLoaded');
		sittingFlv.addEventListener('ready', countLoadedEvent);
		walkingFlv.addEventListener('ready', countLoadedEvent);
		hatFlv.addEventListener('ready', countLoadedEvent);
		shoeFlv.addEventListener('ready', countLoadedEvent);
		//
		resetBtn.addEventListener('click', new EventProxy(this, 'reset'));
		//
		reset();
	}
}